{ Copyright (C) 1998/99, written by Shkolnik Mike
  FIDOnet: 2:463/106.14
  E-Mail:  mshkolnik@scalabium.com
           mshkolnik@yahoo.com
  WEB: http://www.scalabium.com
       http://www.geocities.com/mshkolnik
  tel: 380-/44/-552-10-29

  This component allows to define a min/max values for end-user's entering,
  to check a type of value (date, integer, number etc).
  Also you can change the alignment and use the right-aligned button.
  For button you can define the width, hint and glyph style
  (bsNone, bsDropDown, bsElipsis, bsCustom)

  To use:
   - drop component on form
   - set the EnabledLimit property in True for activation of limitation on MIN/MAX
   - set the EnabledTypedLimit property in True for activation of check on value type
}

unit EditType;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, Buttons, Menus, SMCnst;

type TTypeForEdit = (teString, teStringUpper, teStringLower,
                     teNumber, teInteger,
                     teDateTime, teShortDateTime, teDateShortTime, teShortDateShortTime,
                     teDate, teShortDate,
                     teTime, teShortTime,
                     tePhone, tePhoneExt, teSocial, teZIPCode);
type
  TSMButtonStyle = (bsNone, bsCustom, bsDropDown, bsEllipsis,
                    bsCalculator, bsCalendar, bsFile, bsDirectory,
                    bsOk, bsCancel, bsFind, bsSearch, bsSum);

  TCustomEditButton = class(TCustomMaskEdit)
  private
    { Private declarations }
    MouseInControl: Boolean;
    FFlat: Boolean;

    FButton: TSpeedButton;
    FBtnControl: TWinControl;
    FOnButtonClick: TNotifyEvent;
    FButtonStyle: TSMButtonStyle;
    FButtonKey: TShortCut;

    FAlignment: TAlignment;

    {for flat support}
    procedure SetFlat(Value: Boolean);
    procedure RedrawBorder(const Clip: HRGN);
    procedure NewAdjustHeight;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMNCCalcSize(var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint(var Message: TMessage); message WM_NCPAINT;

    procedure SetAlignment(Value: TAlignment);
    procedure CMEnter(var Message: TCMEnter); message CM_ENTER;
    procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;

    function GetGlyph: TBitmap;
    procedure SetGlyph(Value: TBitmap);
    function GetNumGlyphs: TNumGlyphs;
    procedure SetNumGlyphs(Value: TNumGlyphs);
    function GetButtonWidth: Integer;
    procedure SetButtonWidth(Value: Integer);
    function GetButtonHint: string;
    procedure SetButtonHint(const Value: string);
    procedure SetButtonStyle(Value: TSMButtonStyle);
    procedure EditButtonClick(Sender: TObject);
    procedure RecreateGlyph;
    procedure SetEditRect;
    procedure UpdateBtnBounds;
    function GetMinHeight: Integer;
    function GetTextHeight: Integer;

    function GetButtonFlat: Boolean;
    procedure SetButtonFlat(Value: Boolean);

    function GetPasswordChar: Char;
    procedure SetPasswordChar(Value: Char);
  protected
    { Protected declarations }
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure Loaded; override;
    procedure ButtonClick; dynamic;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    property Flat: Boolean read FFlat write SetFlat;

    property Button: TSpeedButton read FButton;
    property Alignment: TAlignment read FAlignment write SetAlignment;

    property Glyph: TBitmap read GetGlyph write SetGlyph;
    property ButtonStyle: TSMButtonStyle read FButtonStyle write SetButtonStyle default bsCustom;
    property ButtonWidth: Integer read GetButtonWidth write SetButtonWidth;
    property NumGlyphs: TNumGlyphs read GetNumGlyphs write SetNumGlyphs;
    property ButtonHint: string read GetButtonHint write SetButtonHint;
    property ButtonKey: TShortCut read FButtonKey write FButtonKey;
    property ButtonFlat: Boolean read GetButtonFlat write SetButtonFlat;
    property PasswordChar: Char read GetPasswordChar write SetPasswordChar default #0;
    property OnButtonClick: TNotifyEvent read FOnButtonClick write FOnButtonClick;
  end;

  TEditTyped = class(TCustomEditButton)
  private
    { Private declarations }
    FOldText: string;

    FMinValue, FMaxValue: String;
    FTypeValue: TTypeForEdit;
    FEnabledLimit, FEnabledTypedLimit: Boolean;

    procedure SetMinValue(Value: string);
    procedure SetMaxValue(Value: string);
    procedure SetTypeValue(Value: TTypeForEdit);
    procedure SetEnabledLimit(Value: Boolean);
    procedure SetEnabledTypedLimit(Value: Boolean);

    procedure SetMaskForEdit;
    function GetTypeName: string;
    function SetValue(var Dest: string; Source: string): Boolean;
    function GetValue: Variant;
    procedure CMEnter(var Message: TCMEnter); message CM_ENTER;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
  protected
    { Protected declarations }
    procedure KeyPress(var Key: Char); override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    function IsChanged: Boolean;
  published
    { Published declarations }
    property Alignment;
    property MinValue: String read FMinValue write SetMinValue;
    property MaxValue: String read FMaxValue write SetMaxValue;
    property TypeValue: TTypeForEdit read FTypeValue write SetTypeValue;
    property Value: Variant read GetValue;
    property EnabledLimit: Boolean read FEnabledLimit write SetEnabledLimit;
    property EnabledTypedLimit: Boolean read FEnabledTypedLimit write SetEnabledTypedLimit;
//    property MaskState;
    function ConvertValue(Source: string): Variant;

    property Flat;

    property Glyph;
    property ButtonStyle default bsCustom;
    property ButtonWidth;
    property NumGlyphs;
    property ButtonHint;
    property ButtonKey;
    property ButtonFlat;
    property OnButtonClick;

    property AutoSelect;
    property AutoSize;
    property BorderStyle;
    property CharCase;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property EditMask;
    property Font;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

procedure Register;

implementation
{$R *.RES}
{$IFDEF VER140} uses Variants ;{$ENDIF}

const
  DefEditBtnWidth = 21;

procedure Register;
begin
  RegisterComponents('SMComponents', [TEditTyped]);
end;

function Min(A, B: Integer): Integer;
begin
  if A < B then
    Result := A
  else
    Result := B
end;

function Max(A, B: Integer): Integer;
begin
  if A < B then
    Result := B
  else
    Result := A
end;

{ TCustomEditButton }
constructor TCustomEditButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FAlignment := taLeftJustify;
  Flat := False;

  FBtnControl := TWinControl.Create(Self);
  with FBtnControl do
    ControlStyle := ControlStyle + [csReplicatable];
  FBtnControl.Width := 0; //DefEditBtnWidth;
  FBtnControl.Height := 17;
  FBtnControl.Visible := True;
  FBtnControl.Parent := Self;

  FButton := TSpeedButton.Create(Self);
  FButton.SetBounds(0, 0, FBtnControl.Width, FBtnControl.Height);
  FButton.Visible := True;
  FButton.Parent := FBtnControl;
  FButton.OnClick := EditButtonClick;
  Height := 21;
  FButtonStyle := bsNone;
  FButtonKey := scAlt + vk_Down;
end;

destructor TCustomEditButton.Destroy;
begin
  FButton.OnClick := nil;
  inherited Destroy;
end;

procedure TCustomEditButton.CreateParams(var Params: TCreateParams);
const Alignments: array[TAlignment] of Longint =
      (ES_LEFT, ES_RIGHT, ES_CENTER);
      Multilines: array[Boolean] of dWord = (0, ES_MULTILINE);
begin
  inherited CreateParams(Params);

  Params.Style := Params.Style or
                  Multilines[PasswordChar = #0] or
                  Alignments[FAlignment];
end;

procedure TCustomEditButton.CreateWnd;
begin
  inherited CreateWnd;

  SetEditRect;
end;

procedure TCustomEditButton.SetFlat(Value: Boolean);
begin
  if FFlat <> Value then
  begin
    FFlat := Value;
    if Value then
    begin
      BorderStyle := TBorderStyle(bsNone);
      ControlStyle := ControlStyle - [csFramed]; {fixes a VCL bug with Win 3.x}
    end
    else
    begin
      BorderStyle := bsSingle;
//      ControlStyle := ControlStyle + [csFramed];
    end;
    Ctl3D := not Value;
  end;
end;

procedure TCustomEditButton.CMMouseEnter(var Message: TMessage);
begin
  inherited;

  if Flat then
  begin
    MouseInControl := True;
    RedrawBorder(0);
  end;
end;

procedure TCustomEditButton.CMMouseLeave(var Message: TMessage);
begin
  inherited;

  if Flat then
  begin
    MouseInControl := False;
    RedrawBorder(0);
  end;
end;

procedure TCustomEditButton.NewAdjustHeight;
var
  DC: HDC;
  SaveFont: HFONT;
  Metrics: TTextMetric;
begin
  DC := GetDC(0);
  SaveFont := SelectObject(DC, Font.Handle);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);

  Height := Metrics.tmHeight + 6;
end;

procedure TCustomEditButton.Loaded;
begin
  inherited Loaded;

  if not (csDesigning in ComponentState) and Flat then
    NewAdjustHeight;
end;

procedure TCustomEditButton.CMEnabledChanged(var Message: TMessage);
const
  EnableColors: array[Boolean] of TColor = (clBtnFace, clWindow);
begin
  inherited;

  if Flat then
    Color := EnableColors[Enabled];
end;

procedure TCustomEditButton.CMFontChanged(var Message: TMessage);
begin
  inherited;

  if not ((csDesigning in ComponentState) and (csLoading in ComponentState)) and Flat then
    NewAdjustHeight;
end;

procedure TCustomEditButton.WMSetFocus(var Message: TWMSetFocus);
begin
  inherited;

  if not (csDesigning in ComponentState) and Flat then
    RedrawBorder(0);
end;

procedure TCustomEditButton.WMKillFocus(var Message: TWMKillFocus);
begin
  inherited;

  if not(csDesigning in ComponentState) and Flat then
    RedrawBorder(0);
end;

procedure TCustomEditButton.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;

  if Flat then
    InflateRect(Message.CalcSize_Params^.rgrc[0], -3, -3);
end;

procedure TCustomEditButton.WMNCPaint(var Message: TMessage);
begin
  inherited;

  if Flat then
    RedrawBorder(Message.WParam);
end;

procedure TCustomEditButton.RedrawBorder(const Clip: HRGN);
var
  DC: HDC;
  R: TRect;
  NewClipRgn: HRGN;
  BtnFaceBrush, WindowBrush: HBRUSH;
begin
  DC := GetWindowDC(Handle);
  try
    { Use update region }
    if Clip <> 0 then
    begin
      GetWindowRect(Handle, R);
      { An invalid region is generally passed when the window is first created }
      if SelectClipRgn(DC, Clip) = ERROR then {ERROR = 0 in Windows.Pas}
      begin
        NewClipRgn := CreateRectRgnIndirect(R);
        SelectClipRgn(DC, NewClipRgn);
        DeleteObject(NewClipRgn);
      end;
      OffsetClipRgn(DC, -R.Left, -R.Top);
    end;

    GetWindowRect(Handle, R);
    OffsetRect(R, -R.Left, -R.Top);
    BtnFaceBrush := CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
    WindowBrush := CreateSolidBrush(GetSysColor(COLOR_WINDOW));
    if ((csDesigning in ComponentState) and Enabled) or
       (not(csDesigning in ComponentState) and
        (Focused or (MouseInControl and not (Screen.ActiveControl is TCustomEditButton)))) then
    begin
      DrawEdge(DC, R, BDR_SUNKENOUTER, BF_RECT or BF_ADJUST);
      FrameRect(DC, R, BtnFaceBrush);
      InflateRect(R, -1, -1);
      FrameRect(DC, R, WindowBrush);
    end
    else
    begin
      FrameRect(DC, R, BtnFaceBrush);
      InflateRect(R, -1, -1);
      FrameRect(DC, R, BtnFaceBrush);
      InflateRect(R, -1, -1);
      FrameRect(DC, R, WindowBrush);
    end;
    DeleteObject(WindowBrush);
    DeleteObject(BtnFaceBrush);
  finally
    ReleaseDC(Handle, DC);
  end;
end;

function TCustomEditButton.GetPasswordChar: Char;
begin
  Result := inherited PasswordChar;
end;

procedure TCustomEditButton.SetPasswordChar(Value: Char);
begin
  if PasswordChar <> Value then
  begin
    inherited PasswordChar := Value;

    RecreateWnd;
  end;
end;

procedure TCustomEditButton.SetAlignment(Value: TAlignment);
begin
  if FAlignment <> Value then
  begin
    FAlignment := Value;
    RecreateWnd;
  end;
end;

function TCustomEditButton.GetButtonWidth: Integer;
begin
  Result := FButton.Width;
end;

procedure TCustomEditButton.SetButtonWidth(Value: Integer);
begin
  if (csCreating in ControlState) then
  begin
    FBtnControl.Width := Value;
    FButton.Width := Value;
    RecreateGlyph;
  end
  else
    if (Value <> ButtonWidth) and (Value < ClientWidth) then
    begin
      FButton.Width := Value;
      if HandleAllocated then RecreateWnd;
      RecreateGlyph;
    end;
end;

function TCustomEditButton.GetButtonHint: string;
begin
  Result := FButton.Hint;
end;

procedure TCustomEditButton.SetButtonHint(const Value: string);
begin
  FButton.Hint := Value;
end;

function TCustomEditButton.GetButtonFlat: Boolean;
begin
  Result := FButton.Flat;
end;

procedure TCustomEditButton.SetButtonFlat(Value: Boolean);
begin
  FButton.Flat := Value;
end;

function TCustomEditButton.GetGlyph: TBitmap;
begin
  Result := FButton.Glyph;
end;

procedure TCustomEditButton.SetGlyph(Value: TBitmap);
begin
  FButton.Glyph := Value;
//  FButtonStyle := bsCustom;
end;

function TCustomEditButton.GetNumGlyphs: TNumGlyphs;
begin
  Result := FButton.NumGlyphs;
end;

procedure TCustomEditButton.SetNumGlyphs(Value: TNumGlyphs);
begin
  if FButtonStyle in [bsDropDown, bsEllipsis, bsCalculator, bsCalendar, bsFile, bsDirectory] then
    FButton.NumGlyphs := 1
  else
    FButton.NumGlyphs := Value;
end;

procedure TCustomEditButton.EditButtonClick(Sender: TObject);
begin
  ButtonClick;
end;

procedure TCustomEditButton.ButtonClick;
begin
  if (ButtonWidth > 0) and Assigned(FOnButtonClick) then
    FOnButtonClick(Self);
end;

procedure TCustomEditButton.SetButtonStyle(Value: TSMButtonStyle);
begin
  if (FButtonStyle <> Value) then
  begin
    FButtonStyle := Value;
    if (FButtonStyle = bsNone) or
       ((FButtonStyle = bsCustom) and (csReading in ComponentState)) then
      Glyph := nil;

    RecreateGlyph;
    case FButtonStyle of
      bsNone: FButton.Width := 0;
      bsDropDown: ButtonWidth := GetSystemMetrics(SM_CXVSCROLL);
      bsCalculator, bsCalendar: ButtonWidth := 17;
    else
      ButtonWidth := DefEditBtnWidth;
    end;
  end;
end;


procedure TCustomEditButton.RecreateGlyph;

  function CreateEllipsisGlyph: TBitmap;
  var W, G, I: Integer;
  begin
    Result := TBitmap.Create;
    with Result do
    try
      Monochrome := True;
      Width := Max(1, FButton.Width - 6);
      Height := 4;
      W := 2;
      G := (Result.Width - 3 * W) div 2;
      if G <= 0 then G := 1;
      if G > 3 then G := 3;
      I := (Width - 3 * W - 2 * G) div 2;
      PatBlt(Canvas.Handle, I, 1, W, W, BLACKNESS);
      PatBlt(Canvas.Handle, I + G + W, 1, W, W, BLACKNESS);
      PatBlt(Canvas.Handle, I + 2 * G + 2 * W, 1, W, W, BLACKNESS);
    except
      Free;
      raise;
    end;
  end;

var NewGlyph: TBitmap;
begin
  case FButtonStyle of
    bsDropDown: FButton.Glyph.Handle := LoadBitmap(0, PChar(32738));
    bsEllipsis: begin
                  NewGlyph := CreateEllipsisGlyph;
                  try
                    FButton.Glyph := NewGlyph;
                  finally
                    NewGlyph.Destroy;
                  end;
                end;
    bsCalculator: FButton.Glyph.Handle := LoadBitmap(hInstance, 'CALCULATORBMP');
    bsCalendar: FButton.Glyph.Handle := LoadBitmap(hInstance, 'CALENDARBMP');
    bsFile: FButton.Glyph.Handle := LoadBitmap(hInstance, 'FILEBMP');
    bsDirectory: FButton.Glyph.Handle := LoadBitmap(hInstance, 'DIRECTORYBMP');
    bsOk: FButton.Glyph.Handle := LoadBitmap(hInstance, 'OKBMP');
    bsCancel: FButton.Glyph.Handle := LoadBitmap(hInstance, 'CANCELBMP');
    bsFind: FButton.Glyph.Handle := LoadBitmap(hInstance, 'FINDBMP');
    bsSearch: FButton.Glyph.Handle := LoadBitmap(hInstance, 'SEARCHBMP');
    bsSum: FButton.Glyph.Handle := LoadBitmap(hInstance, 'SUMBMP');
  end;
  if (FButtonStyle <> bsCustom) then
    NumGlyphs := 1;
end;

procedure TCustomEditButton.SetEditRect;
var Loc: TRect;
begin
  SetRect(Loc, 0, 0, ClientWidth - FBtnControl.Width - 2, ClientHeight + 1);
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
end;

procedure TCustomEditButton.UpdateBtnBounds;
begin
  if NewStyleControls then
  begin
    if Ctl3D or Flat then
//      FBtnControl.SetBounds(Width - FButton.Width - 4, 0, FButton.Width, Height - 4)
      FBtnControl.SetBounds(ClientWidth - FButton.Width, 0, FButton.Width, ClientHeight)
    else
//      FBtnControl.SetBounds(Width - FButton.Width - 2, 2, FButton.Width, Height - 4);
      FBtnControl.SetBounds(ClientWidth - FButton.Width - 2, 1, FButton.Width, ClientHeight-2);
  end
  else
    FBtnControl.SetBounds(Width - FButton.Width - 2, 1, FButton.Width, ClientHeight - 2);
  FButton.Height := FBtnControl.Height;
  SetEditRect;
end;

procedure TCustomEditButton.CMCtl3DChanged(var Message: TMessage);
begin
  inherited;

  UpdateBtnBounds;
end;

procedure TCustomEditButton.WMSize(var Message: TWMSize);
var MinHeight: Integer;
begin
  inherited;

  if not (csLoading in ComponentState) then
  begin
    MinHeight := GetMinHeight;
    { text edit bug: if size to less than MinHeight, then edit ctrl does
      not display the text }
    if Height < MinHeight then
    begin
      Height := MinHeight;
      Exit;
    end;
  end;
  UpdateBtnBounds;
end;

function TCustomEditButton.GetTextHeight: Integer;
var DC: HDC;
    SaveFont: HFont;
    SysMetrics, Metrics: TTextMetric;
begin
  DC := GetDC(0);
  try
    GetTextMetrics(DC, SysMetrics);
    SaveFont := SelectObject(DC, Font.Handle);
    GetTextMetrics(DC, Metrics);
    SelectObject(DC, SaveFont);
  finally
    ReleaseDC(0, DC);
  end;
  Result := Min(SysMetrics.tmHeight, Metrics.tmHeight);
end;

function TCustomEditButton.GetMinHeight: Integer;
var i: Integer;
begin
  i := GetTextHeight;
  Result := i + GetSystemMetrics(SM_CYBORDER) * 4 + 1 + (i div 4);
end;

procedure TCustomEditButton.CMEnter(var Message: TCMEnter);
begin
  inherited;

  if AutoSelect then
    SendMessage(Handle, EM_SETSEL, 0, -1);
end;

procedure TCustomEditButton.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);

  if (FButtonKey = ShortCut(Key, Shift)) and (ButtonWidth > 0) then
  begin
    EditButtonClick(Self);
    Key := 0;
  end;
end;


{ TEditTyped }
constructor TEditTyped.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  SetMaskForEdit;
  EnabledTypedLimit := True;

  FOldText := '';
end;

procedure TEditTyped.SetMaskForEdit;
begin
  EditMask := '';

  case FTypeValue of
    teString: CharCase := ecNormal;
    teStringUpper: CharCase := ecUpperCase;
    teStringLower: CharCase := ecLowerCase;
//    teNumber: EditMask := '### ### ### ##0.00;1;_';
    teDateTime: EditMask := '!99/99/9999 99:99:99;1;_';
    teShortDateTime: EditMask := '!99/99/99 99:99:99;1;_';
    teDateShortTime: EditMask := '!99/99/9999 99:99;1;_';
    teShortDateShortTime: EditMask := '!99/99/99 99:99;1;_';
    teDate: EditMask := '!99/99/9999;1;_';
    teShortDate: EditMask := '!99/99/99;1;_';
    teTime: EditMask := '!90:99:99;1;_';
    teShortTime: EditMask := '!99:99;1;_';
    tePhone: EditMask := '!\(999\) 999\-9999;1;_';
    tePhoneExt: EditMask := '!\(999\) 999\-9999 \x9999;1;_';
    teSocial: EditMask := '!999\-99\-9999;1;_';
    teZIPCode: EditMask := '!99999\-9999;1;_';
  end;
{  if FTypeValue in [teInteger, teNumber] then
    SetAlignment(taRightJustify)
  else
    SetAlignment(taLeftJustify);
}end;

function TEditTyped.GetTypeName: string;
begin
  case FTypeValue of
    teNumber: Result := etValidNumber;
    teInteger: Result := etValidInteger;
    teDateTime,
    teShortDateTime,
    teDateShortTime,
    teShortDateShortTime: Result := etValidDateTime;
    teDate,
    teShortDate: Result := etValidDate;
    teTime,
    teShortTime: Result := etValidTime;
  else
    Result := etValid;
  end;
end;

procedure TEditTyped.SetMinValue(Value: String);
begin
  if FMinValue <> Value then
    SetValue(FMinValue, Value);
end;

procedure TEditTyped.SetMaxValue(Value: String);
begin
  if FMaxValue <> Value then
    SetValue(FMaxValue, Value);
end;

procedure TEditTyped.SetTypeValue(Value: TTypeForEdit);
begin
  if FTypeValue <> Value then
  begin
    FTypeValue := Value;
    SetMaskForEdit;
  end;
end;

procedure TEditTyped.SetEnabledLimit(Value: Boolean);
begin
  if FEnabledLimit <> Value then
    FEnabledLimit := Value;
end;

procedure TEditTyped.SetEnabledTypedLimit(Value: Boolean);
begin
  if FEnabledTypedLimit <> Value then
    FEnabledTypedLimit := Value;
end;

function TEditTyped.ConvertValue(Source: string): Variant;

  function Stuff(strStr: string; intIndex, intCount: Integer; strSub: string): string;
  begin
    Result := strStr;
    Delete(Result, intIndex, intCount);
    Insert(strSub, Result, intIndex);
  end;

var varForConvert: Variant;
    str, strOldMaskEdit, strEditText: string;
begin
  Result := Null;

  try
    {save current editing text}
    strEditText := EditText;
    Text := Source;

    {change a mask for check of the null string}
    str := Stuff(EditMask, Length(EditMask)-2, 1, '0');
    strOldMaskEdit := EditMask;
    ReformatText(str);
    str := Text;
    ReformatText(strOldMaskEdit);

    {restore a saved editing text}
    EditText := strEditText;

    if (Source = '') or (Trim(str) = '') then
    begin
      varForConvert := NULL;
{      case FTypeValue of
        teNumber,
        teInteger: varForConvert := 0;
        teDateTime,
        teShortDateTime,
        teDateShortTime,
        teShortDateShortTime: varForConvert := 0;
        teDate,
        teShortDate: varForConvert := 0;
        teTime,
        teShortTime: varForConvert := 0;
      else
        varForConvert := ''
      end;
}    end
    else
    begin
      case FTypeValue of
        teNumber: varForConvert := StrToFloat(Source);
//        {$IFDEF VER130}
//        teInteger: varForConvert := StrToInt64(Source);
//        {$ELSE}
        teInteger: varForConvert := StrToInt(Source);
//        {$ENDIF}
        teDateTime,
        teShortDateTime,
        teDateShortTime,
        teShortDateShortTime: varForConvert := StrToDateTime(Source);
        teDate,
        teShortDate: varForConvert := StrToDate(Source);
        teTime,
        teShortTime: varForConvert := StrToTime(Source);
      else
        varForConvert := Source
      end;
    end;
    Result := varForConvert
  except
    raise EConvertError.CreateFmt('"%s" %s %s', [Source, etIsNot, GetTypeName()])
  end;
end;

function TEditTyped.SetValue(var Dest: String; Source: String): Boolean;
var varForConvert: Variant;
begin
  varForConvert := ConvertValue(Source);
  Result := not varIsNull(varForConvert);
  if Result then Dest := Source;
end;

procedure TEditTyped.CMEnter(var Message: TCMEnter);
begin
  FOldText := Text;

  inherited;
end;

procedure TEditTyped.CMExit(var Message: TCMExit);
var varValue, varMin, varMax: Variant;
    strValue: string;
begin
  try
    if (FEnabledTypedLimit = True) then
      SetValue(strValue, Text);

    if (FEnabledLimit = True) then
    begin
      varValue := ConvertValue(Text);
      varMin   := ConvertValue(FMinValue);
      varMax   := ConvertValue(FMaxValue);

      if ((varValue < varMin) or (varValue > varMax)) then
      begin
        if not (csDesigning in ComponentState) then
        begin
          raise ERangeError.CreateFmt(etOutOfRange, [Text, FMinValue, FMaxValue]);
        end;
      end;
    end;

    inherited;
  except
    SetFocus;
    raise;
  end;
end;

procedure TEditTyped.KeyPress(var Key: Char);
const
  Alpha= [#1..#255]; //'A'..'Z', 'a'..'z', '_'];
  NumericOnly = ['0'..'9'];
  SignOnly = ['-', '+'];
  Numeric = SignOnly + NumericOnly;
var
  boolCallInherited: Boolean;
  frmParent: TCustomForm;
begin
  boolCallInherited := True;
  if FEnabledTypedLimit and not (Key in [#0, #8, #13]) then
  begin
    case FTypeValue of
      teNumber: begin
                  if (Key in ['.', ',']) then
                    Key := DecimalSeparator;

                  boolCallInherited := (((Key = DecimalSeparator) or (Key in SignOnly)) and (Pos(Key, Text) = 0))
                                       or (Key in Numeric) or (Key in ['E', 'e']);
                end;

      teInteger: boolCallInherited := ((Key in SignOnly) and (Pos(Key, Text) = 0))
                                  or (Key in Numeric);

      teDateTime,
      teShortDateTime,
      teDateShortTime,
      teShortDateShortTime,
      teDate,
      teShortDate,
      teTime,
      teShortTime: boolCallInherited := (Key in Numeric);

    end;
  end;

  if boolCallInherited then
  begin
    if (Key = Char(VK_RETURN)) then
    begin
      frmParent := GetParentForm(Self);
      SendMessage(frmParent.Handle, WM_NEXTDLGCTL, 0, 0);
      Key := #0;
    end
  end
  else
  begin
    MessageBeep(0);
    Key := #0;
  end;

  inherited KeyPress(Key);
end;

function TEditTyped.GetValue: Variant;
begin
  Result := ConvertValue(Text);
end;

function TEditTyped.IsChanged: Boolean;
begin
  Result := (Text <> FOldText);
end;

end.
